import processing.core.*; 
import processing.xml.*; 

import processing.serial.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class multitouch_viz extends PApplet {



Serial myPort;  // Create object from Serial class
int RUNNING_AVERAGE_SIZE = 2;

int[][][] readings = new int[4][4][RUNNING_AVERAGE_SIZE];
int average_pos = 0;

public void setup()
{
  size(1000, 600, P3D);
  String portName = Serial.list()[0];
  println(portName);
  myPort = new Serial(this, portName, 115200); 
  myPort.clear();
  smooth();
}

public void draw_pads()
{
  float[][] panel_heights = new float[4][4];
  float min_panel = 1000;
  for (int i = 0; i < 4; ++i) {
    for (int j = 0; j < 4; ++j) {
      for (int k = 0; k < RUNNING_AVERAGE_SIZE; ++k)
        panel_heights[i][j] += readings[3-i][j][k];
      panel_heights[i][j] /= PApplet.parseFloat(RUNNING_AVERAGE_SIZE);
      panel_heights[i][j] = (70 - panel_heights[i][j])  / 40.f;
      if (panel_heights[i][j] < min_panel)
        min_panel = panel_heights[i][j];
    }
  }
  
  stroke(255);
  translate(width/2.f, height/2.f, 0);
  scale(height/4.f * 0.9f, height/4.f * 0.9f, height/4.f * 0.9f);
  translate(0, 0, -1);
  rotateX(radians(45));
  rotateZ(radians(5));
  
  for (int i = 0; i < 4; ++i) {
    for (int j = 0; j < 4; ++j) {
      float panel_height = panel_heights[i][j] - min_panel;

      pushMatrix();
      translate(i - 1.5f, j - 1.5f, 0);

      if (panel_height > 0.6f) {
        stroke(0, 255, 0);
        strokeWeight(5);
      } else {
        stroke(64 + 128 * panel_height);
        strokeWeight(1);
      }
        
        fill(255, (panel_height - 0.4f) / 0.4f * 255.0f);

      beginShape(QUADS);
      vertex(-0.5f, -0.5f, panel_height);
      vertex( 0.5f, -0.5f, panel_height);
      vertex( 0.5f,  0.5f, panel_height);
      vertex(-0.5f,  0.5f, panel_height);
      endShape();
      
      popMatrix();
    }
  }
}

public void draw()
{
  background(0);
  noFill();

  char val = 0, temp = 0;
  int pad_reading = 0;
  
  int i = 0, j = 0;

  myPort.clear();

  // Wait we get a sync frame
  do
  {
    while(myPort.available() == 0);
  } while (myPort.readChar() != '\n');

   
  while (j < 4) {
    while(myPort.available() == 0);
    readings[i][j][average_pos] = myPort.read();
    if (++i == 4) {
      i = 0;
      j++;
    }
  }


    draw_pads();
  
    if (++average_pos == RUNNING_AVERAGE_SIZE)
      average_pos = 0;
      
  
}
      

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "multitouch_viz" });
  }
}
